/*
 *     A subroutine for computing non-central multivariate t probabilities.
 *     This subroutine uses an algorithm (QRSVN) described in the paper
 *     "Comparison of Methods for the Computation of Multivariate
 *         t-Probabilities", by Alan Genz and Frank Bretz
 *         J. Comp. Graph. Stat. 11 (2002), pp. 950-971.
 *
 *          Alan Genz
 *          Department of Mathematics
 *          Washington State University
 *          Pullman, WA 99164-3113
 *          Email : AlanGenz@wsu.edu
 *
 *   Original source available from
 *   http://www.math.wsu.edu/faculty/genz/software/fort77/mvtdstpack.f
 */

#include "mvt.h"


extern"C" {
// gfortran
int gsl_rng_uniform_fortran_(double *x, gsl_rng **r, int pointerwaste) {
  *x = gsl_rng_uniform(*r);
  return(1);
}

// g77
int gsl_rng_uniform_fortran__(double *x, gsl_rng **r, int pointerwaste) {
  *x = gsl_rng_uniform(*r);
  return(1);
}
}
