## Starte auf einen Node und reserviere 2 Prozessoren
## qsub -l nodes=1:ppn=2

rjungleExe <- file.path("/projects/rjungle/source/randomjungle-2.0.0/src/./rjungle")
inFile <- file.path("/projects/rjungle/source/randomjungle-2.0.0/tests/testMPI.dat")
outFile <- file.path("/projects/rjungle/source/randomjungle-2.0.0/tests/exampleMPI")

n <- 10
df <- data.frame(y = rbinom(n, 1, 0.5),
                 matrix(rnorm(10*n), 10, 10))
write.table(df, inFile, row.names = FALSE, quote = FALSE)

rjungleCMD <- paste(rjungleExe,
                    "-f", inFile,
                    "-v -i2",
                    "-D y",
                    "-U8", ## 2 CPUs
                    "-o", outFile
                    )
system.time(try(system(rjungleCMD)))

checkTime <- function(nCPU){
  rjungleCMD <- paste(rjungleExe,
                      "-f", inFile,
                      "-v -i2",
                      "-D y",
                      "-U", nCPU,
                      "-o", outFile
                      )
  time <- system.time(try(system(rjungleCMD)))
  return(time)
}

timeList <- vector("list")
for(i in c(1,5,10,20,50)){
  timeList[[i]] <- checkTime(i)
}
